;=======================================================================
;					   PIC16F84A.
;=======================================================================
;				  :
;					- PIC16F84A-20-I/P
;=======================================================================
;					  :
;		R (17)  -   .
;		R1 (18)  -   .
;		RA2 (l)   -    .
;		RA3 (2)   -   .
;		R4 (3)   -   .
;		RB0 (6)	  -      .
;		R7 (13)  -    ..
;		RB3 (9)	  - _1  .
;		RB4 (10)  - _2  .
;		R5 (11)  - _3  .
;		R2 (8)   - _4  .
;		R1 (7)   -     .
;		R6 (12)  -     .
;=======================================================================
			list      p=16F84A
			#include <p16F84A.inc>
			__CONFIG _CP_OFF&_WDT_OFF&_PWRTE_ON&_HS_OSC
;=======================================================================
;								.
;=======================================================================
cnt_delay		EQU		0x10
w_temp			EQU		0x11
key				EQU		0x12
flag			EQU		0x13
Const			EQU		0x14
;-----------------------------------------------------------------------
;							 .
;-----------------------------------------------------------------------
bin1			EQU		0x15
bin2			EQU		0x16
bcd1			EQU		0x17
bcd2			EQU		0x18
bcd3			EQU		0x19
ctr				EQU		0x1A
;-----------------------------------------------------------------------
;							 .
;-----------------------------------------------------------------------
Cnt_On_Off		EQU		0x1B	;  ./. .
cnt1			EQU		0x1C	;   1 .
cnt2			EQU		0x1D	;   2 .
cnt3			EQU		0x1E	;   3  .
cnt_dig			EQU		0x1F	;   .
cnt_Ind			EQU		0x20	;   .
Ind_1			EQU		0x21	;    .
Ind_2			EQU		0x22	;    .
digit_1			EQU		0x23	;    .
digit_2			EQU		0x24	;    .
digit_3			EQU		0x25	;    .
digit_4			EQU		0x26	;    .
digit_5			EQU		0x27	;    .
digit_6			EQU		0x28	;    .
digit_7			EQU		0x29	;    .
digit_8			EQU		0x2A	;    .
;-----------------------------------------------------------------------
;							 .
;-----------------------------------------------------------------------
Speed			EQU		0x2B	;  .
Speed_L			EQU		0x2C	;   ().
Speed_H			EQU		0x2D	;   ().
;-----------------------------------------------------------------------
;							  .
;-----------------------------------------------------------------------
Speeder			EQU		0x2E	;   .
Speeder_L		EQU		0x2F	;   .
Speeder_H		EQU		0x30	;   .
Speeder_1		EQU		0x31	;   .
Speeder_2		EQU		0x32	;   .
;-----------------------------------------------------------------------
;							  .
;-----------------------------------------------------------------------
bcd_t			EQU		0x33
Oil_zalito		EQU		0x34	;   .
Oil_razhod		EQU		0x35	;   .
Fors			EQU		0x36	;   .
Cnt_Fors_1		EQU		0x37	;    .
Cnt_Fors_2		EQU		0x38
Dlit_Fors_1		EQU		0x39	;    .
Dlit_Fors_2		EQU		0x3A	;
Dlit_Fors_H		EQU		0x3B	;
Dlit_Fors_L		EQU		0x3C	;    .
;-----------------------------------------------------------------------
;							 .
;-----------------------------------------------------------------------
cels_H			EQU		0x3D
cels_L			EQU		0x3E
cels_H1			EQU		0x3F
cels_L1			EQU		0x40
cels_H2			EQU		0x41
cels_L2			EQU		0x42
minus			EQU		0x43
minus1			EQU		0x44
minus2			EQU		0x45
;=======================================================================
;	       1-WIRE.
;=======================================================================
LSB				EQU		0x46
MSB				EQU		0x47
TEMP			EQU		0x48
TEMP_2			EQU		0x49
I_BYTE			EQU		0x4A
I_BYTE_2		EQU		0x4B
O_BYTE			EQU		0x4C 
O_BYTE_2		EQU		0x4D
_N				EQU		0x4E
LOOP1			EQU		0x4F
;-----------------------------------------------------------------------
	CONSTANT			DATA_PIN=3
	CONSTANT			DATA_PIN_2=0
;=======================================================================
;							 EEPROM.
;=======================================================================
Status			EQU		0x03
EEData			EQU		0x08
EEAdr			EQU		0x09
IntCon			EQU		0x0B
EECon1			EQU		0x88
EECon2			EQU		0x89
temp_RD			EQU		0x0C	;   .
temp_WR			EQU		0x0D	;   .
cnt_ADR			EQU		0x0E	;  .
cnt_DATA		EQU		0x0F	;  .
;=======================================================================
;								.
;=======================================================================
;	flag, 0		-	 /  
;					 .
;		  0		-	 .
;		  1		-	 .
;	flag, 1		-	   .
;		  0		-	 .
;		  1		-	   .
;	flag, 2		-	   .
;		  0		-	  .
;		  1		-	 .
;	flag, 3		-	  .
;		  0		-	 .
;		  1		-	 .
;	flag, 4		-	 /    .
;		  0		-	 .
;		  1		-	 .
;	flag, 5		-	    EEPROM.
;		  0		-	  .
;		  1		-	 .
;	flag, 6		-	 / .
;		  0		-	   (HG1).
;		  1		-	   (HG2).
;	flag, 7		-	 /   .
;		  0		-	 .
;		  1		-	 .
;=======================================================================
	ORG		0x00
	goto	Start
;=======================================================================
;				      HG1.
;=======================================================================
Convert_HG1
	addwf	PCL, f
;			 'DHCGBFAE'
	retlw	b'01010000'		; 0
	retlw	b'11010111'		; 1
	retlw	b'01100100'		; 2
	retlw	b'01000101'		; 3
	retlw	b'11000011'		; 4
	retlw	b'01001001'		; 5
	retlw	b'01001000'		; 6
	retlw	b'11010101'		; 7
	retlw	b'01000000'		; 8
	retlw	b'01000001'		; 9
	retlw	b'11000000'		; A
	retlw	b'01000110'		; B
	retlw	b'01111000'		; C -  "  ".
	retlw	b'01001010'		; D -  " D ".
	retlw	b'01101000'		; E
	retlw	b'11101000'		; F
	retlw	b'11111111'		; 10 - OFF
	retlw	b'11101111'		; 11 -   " - ".
;=======================================================================
;				      HG2.
;=======================================================================
Convert_HG2
	addwf	PCL, f
;			 'GBFAEDHC'
	retlw	b'10000010'		; 0
	retlw	b'10111110'		; 1
	retlw	b'00100011'		; 2
	retlw	b'00101010'		; 3
	retlw	b'00011110'		; 4
	retlw	b'01001010'		; 5
	retlw	b'01000010'		; 6
	retlw	b'10101110'		; 7
	retlw	b'00000010'		; 8
	retlw	b'00001010'		; 9
	retlw	b'00000110'		; A
	retlw	b'00110010'		; B
	retlw	b'11000011'		; C -  "  ".
	retlw	b'01010010'		; D -  " D ".
	retlw	b'01000011'		; E
	retlw	b'01000111'		; F
	retlw	b'11111111'		; 10 - OFF
	retlw	b'01111111'		; 11 -   " - ".
;=======================================================================
;							 .
;=======================================================================
Start
	clrf	PORTA			;    .
	clrf	PORTB
	clrf	digit_1
	clrf	digit_2
	clrf	digit_3
	clrf	digit_4
	clrf	digit_5
	clrf	digit_6
	clrf	digit_7
	clrf	digit_8
	clrf	cnt_delay
	clrf	flag
	clrf	Speeder_L
	clrf	Speeder_H
	clrf	Speeder_1
	clrf	Speeder_2
	clrf	Cnt_Fors_1
	clrf	Cnt_Fors_2
	clrf	Dlit_Fors_1
	clrf	Dlit_Fors_2
	clrf	Oil_razhod
	clrf	Oil_zalito
	clrf	minus
	movlw	0x32			;   /
	movwf	Cnt_On_Off		;   .
;-----------------------------------------------------------------------
;								.
;-----------------------------------------------------------------------
	bsf		STATUS, RP0		; bank 1
	movlw	b'00111111'		;   PORTB, 
	movwf	OPTION_REG		;   WDT, . . = 1:128,
							;      RB0.
	movlw	b'00000000'		;   .
	movwf	INTCON
	movlw	b'00011111'		;
	movwf	PORTA			; RA4, RA3, RA1, RA0 , RA2 - .
	movlw	0x00			; b'00000001'
	movwf	PORTB			; RB7 - RB1 , RB0 - .
	bcf		STATUS, RP0		; bank 0
	movlw	0x3C			; b'00111100'
	movwf	TRISB			; 
;=======================================================================
;						   EEPROM.
;=======================================================================
	call	READ_EPROM		;    EEPROM.
	movf	Speed, W
	movwf	w_temp			;   FF  EEPROM  .
	incfsz	w_temp, f		;   = FF,   
	goto	Main			;     .
	movlw	0x7A			;  .
	movwf	Speed
	movlw	0x70			;   .
	movwf	Fors
	movlw	0x0C			;   .
	movwf	Speeder
	call	WRITE_EPROM
	goto	Main
;=======================================================================
;					    EEPROM.
;=======================================================================
READ_EPROM
	movlw	4				;    .
	movwf	cnt_ADR			;    .
;=======================================================================
;					     EEPROM.
;=======================================================================
ADR_RD
	decfsz	cnt_ADR, f		;     =0,
	goto	load_DATA_RD
	return					;    .
load_DATA_RD
	movf	cnt_ADR, W
	movwf	cnt_DATA
	call	READ			;  .
;	decfsz	cnt_DATA, f
;	goto	$+3
;	movwf	digbell_4		;     .
;	goto	ADR_RD
	decfsz	cnt_DATA, f
	goto	$+3
	movwf	Speeder			;     .
	goto	ADR_RD
	decfsz	cnt_DATA, f
	goto	$+3
	movwf	Fors			;     .
	goto	ADR_RD
	decf	cnt_DATA, f
	movwf	Speed			;     .
	goto	ADR_RD
;=======================================================================
;								 EEPROM.
;=======================================================================
READ
	bcf		EECon1, 2		;  , byt_2=0.
	movf	cnt_ADR, W
	movwf	EEAdr			;    .
	bsf		Status, RP0		;    1.
	bsf		EECon1, RD		;     EEPROM.
	bcf		Status, RP0		;    0.
	movf	EEData, W		;   EEData -> W.
	movwf	temp_RD			;   W -> temp_RD.
	return
;=======================================================================
;					    EEPROM.
;=======================================================================
WRITE_EPROM
	movlw	0
	movwf	IntCon		;  .
	movlw	4
	movwf	cnt_ADR		;     .
write
	call	ADR_WR		;    .
	movwf	temp_WR		;     .
	movf	cnt_ADR, W
	btfsc	STATUS, Z	;   =0,   .
	return
;-----------------------------------------------------------------------
;								 EEPROM.
;-----------------------------------------------------------------------
WRITE
	movf	cnt_ADR, W
	movwf	EEAdr		;    .
	movf	temp_WR, W
	movwf	EEData		;  .
	bsf		Status, RP0
	bsf		EECon1, 2	;  
	movlw	055h
	movwf	EECon2
	movlw	0AAh
	movwf	EECon2
	bsf		EECon1, WR	;   .
wr1
	btfss	EECon1, 4	;   .
	goto	wr1
	bcf		EECon1, 4	;   " ".
	bcf		Status, RP0
	goto	write		;      .
;-----------------------------------------------------------------------
;	call	READ		;  .
;-----------------------------------------------------------------------
;Verify
;	movf	temp_WR, W	;  .
;	movwf	Temp
;	movf	temp_RD, W	;  .
;	subwf	Temp, f		;  .
;	btfsc	STATUS, Z	;   =0,  .
;	goto	write		;      .
;	goto	WRITE		;  =0 ,   ,  .
;=======================================================================
;					     EEPROM.
;=======================================================================
ADR_WR
	decfsz	cnt_ADR, f
	goto	load_DATA_WR
	return				;   =0,   .
load_DATA_WR
	movf	cnt_ADR, W
	movwf	cnt_DATA
;	decfsz	cnt_DATA, f
;	goto	$+3
;	movf	digbell_4, W
;	return
	decfsz	cnt_DATA, f
	goto	$+3
	movf	Speeder, W
	return
	decfsz	cnt_DATA, f
	goto	$+3
	movf	Fors, W
	return
	decf	cnt_DATA, f
	movf	Speed, W
	return
;=======================================================================
;							 .
;=======================================================================
Main
	call	Conv_IND	;    .
	call	Ind_LED
	btfsc	PORTA, 0	;   ,    
	goto	main_OFF	;   .
	btfsc	flag, 0		;    ,   
	goto	main_ON		;    .	
	bcf		flag, 0		;    .
	bcf		flag, 1		;     .
	bcf		flag, 2		;    .
	bcf		flag, 7		;     .
	call	Ind_OFF
	goto	Main
main_OFF
	bcf		flag, 0		;    .
main_ON
	call	SpeeD
	call	Conv_IND
	call	Ind_LED
	call	Water_T
	call	Conv_IND
	call	Ind_LED
	call	Water_T_2
	goto	Main
;=======================================================================
;						   .
;=======================================================================
Ind_ON
	clrf	Dlit_Fors_H		;    
	clrf	Dlit_Fors_L		;   .
	call	Conv_IND
	return
;=======================================================================
;					   .
;=======================================================================
Forsunka
	btfss	PORTA, 0		;    .
	return
;		btfss	PORTA, 2
	btfsc	PORTA, 2		;    .
	return
	clrf	Dlit_Fors_H		;    
	clrf	Dlit_Fors_L		;   .
	incfsz	Dlit_Fors_L, f	;    .
	goto	$+2
	incf	Dlit_Fors_H, f
;		btfsc	PORTA, 2
	btfss	PORTA, 2
	goto	$-4				;     RA2.
;=======================================================================
;						  .
;=======================================================================
Fors_Impuls
	movlw	.4
	movwf	ctr
loop_1						;   16.
	bcf		STATUS, C
	rrf		Dlit_Fors_H, f
	rrf		Dlit_Fors_L, f	;     2.
	decfsz	ctr, f
	goto	loop_1
;-----------------------------------------------------------------------
	bcf		STATUS, C
	movf	Dlit_Fors_L, W	;    
	addwf	Cnt_Fors_2, f	;     .
	btfsc	STATUS, C		;   , 
	incf	Cnt_Fors_1, f	; ,   1  . .
;-----------------------------------------------------------------------
	movf	Fors, W			;   .
	bcf		STATUS, C		;   Cnt_Fors_1  
	subwf	Cnt_Fors_1, W	;    1  
	btfss	STATUS, C		; Dlit_Fors_2. 
	return					;      Cnt_Fors_1.
	movlw	0x00
	bcf		STATUS, C
	subwf	Cnt_Fors_2, W
	btfsc	STATUS, C
	goto	$+2
	return
	clrf	Cnt_Fors_1
	movlw	0x00	
	subwf	Cnt_Fors_2, f
	incf	Dlit_Fors_2, f
;-----------------------------------------------------------------------
	bcf		STATUS, C		;     .
	movlw	0x64
	subwf	Dlit_Fors_2, W
	btfss	STATUS, C
	return
	incf	Oil_razhod, f
	movf	Oil_zalito, W	;    = 0,  
	btfsc	STATUS, Z		;    .
	goto	$+2
	decf	Oil_zalito, f
	clrf	Dlit_Fors_2
	return
;=======================================================================
;							  .
;=======================================================================
SpeeD
	clrf	TMR0			;  .
	bsf		STATUS, RP0		; bank 1
	movlw	0x1F			;   .
	movwf	PORTA			; RA4 - .(RA3 - RA0 - .)RA2 - .
	bcf		STATUS, RP0		; bank 0
;-----------------------------------------------------------------------
;					     .
;-----------------------------------------------------------------------
	movf	Speed, W		;  .
	movwf   cnt_Ind
	call    loop_Ind		;   .
;-----------------------------------------------------------------------
	bsf		STATUS, RP0		; bank 1
	movlw	0x0F			;   .
	movwf	PORTA			; RA4 - .(RA3 - RA0 - .)RA2 - .
	bcf		STATUS, RP0		; bank 0
;=======================================================================
;					   .
;=======================================================================
prescaler
;	clrf	Speed_L
	movf    TMR0, W			;  TMR0    W
	movwf   Speed_L
;-----------------------------------------------------------------------
;						  .
;-----------------------------------------------------------------------
	movf	Speed_L, W
	movwf	Speed_H			;   .
	movlw	0x02
	subwf	Speed_H, f		;   < 2 ,  
	btfss	STATUS, C		;  .
	clrf	Speed_L
;=======================================================================
;							 .
;=======================================================================
speder
	bcf		STATUS, C
	movf	Speed_L, W		;    
	addwf	Speeder_L, f	;  .
	btfsc	STATUS, C
	incf	Speeder_H, f
	bcf		STATUS, C
	movf	Speeder, W		;   .
	subwf	Speeder_H, W
	btfss	STATUS, C
	goto	$+6
	bcf		STATUS, C
	movlw	0x00			; 
	subwf	Speeder_L, W
	btfsc	STATUS, C
	goto	$+2
	return
	clrf	Speeder_H
	movlw	0x00			; 	
	subwf	Speeder_L, f
	incfsz	Speeder_2, f
	return
	incf	Speeder_1, f
	return
;=======================================================================
;						   .
;=======================================================================
Conv_IND
	btfsc	flag, 5			;     ,
	goto	Const_Ind		;     .
	btfss	flag, 1			;     ,
	goto	Speed_Ind		;     .
	btfss	flag, 2			;     
	goto	Fors_Ind		;      .
	btfsc	flag, 2			;     ,
	goto	Cels_Ind		;     .
	return
;-----------------------------------------------------------------------
;					    .
;-----------------------------------------------------------------------
Speed_Ind
	clrf	bin1
	movf	Speed_L, W
	movwf	bin2
	movlw	.16
	movwf	ctr
	call	bin2bcd
	call	Conv_IND_58		;  .
	movf	cels_H1, W
	movwf	bcd2
	movf	cels_L1, W
	movwf	bcd3
	call	Conv_IND_14		;   .
	return
;-----------------------------------------------------------------------
;				     .
;-----------------------------------------------------------------------
Fors_Ind
	movf	Oil_razhod, W	;    .
	movwf	bin1			;   .
	movf	Dlit_Fors_2, W
	movwf	bin2
	movlw	.8
	movwf	ctr
	call	bin2bcd
	movf	bcd3, W
	movwf	bcd_t
;-----------------------------------------------------------------------
	movf	Oil_razhod, W	;    .
	movwf	bin2			;   .
	movf	Dlit_Fors_2, W
	movwf	bin1
	movlw	.8
	movwf	ctr
	call	bin2bcd
	movf	bcd_t, W
	movwf	bcd2
	call	Conv_IND_14		;   .
;-----------------------------------------------------------------------
	movf	Speeder_1, W
	movwf	bin1
	movf	Speeder_2, W
	movwf	bin2
	movlw	.16
	movwf	ctr
	call	bin2bcd
	call	Conv_IND_58		;   .
	return
;-----------------------------------------------------------------------
;		       .
;-----------------------------------------------------------------------
Cels_Ind
	movf	cels_H2, W
	movwf	bcd2
	movf	cels_L2, W
	movwf	bcd3
	call	Conv_IND_58		;    .
	clrf	bin1
	movf	Oil_zalito, W
	movwf	bin2
	movlw	.16
	movwf	ctr
	call	bin2bcd
	call	Conv_IND_14		;    .
	return
;-----------------------------------------------------------------------
;						  .
;-----------------------------------------------------------------------
Const_Ind
	btfsc	flag, 1
	goto	Ind_Fors
	clrf	bcd2
	movf	Speed, W
	movwf	bcd3
	call	Conv_IND_14		;   .
	clrf	bin1
	movf	Speed_L, W
	movwf	bin2
	movlw	.16
	movwf	ctr
	call	bin2bcd
	call	Conv_IND_58		;  .
	return
Ind_Fors
	btfsc	flag, 2
	goto	Ind_Speeder
	clrf	bcd2
	movf	Fors, W
	movwf	bcd3
	call	Conv_IND_14		;    .
	movf	Speeder_1, W
	movwf	bin1
	movf	Speeder_2, W
	movwf	bin2
	movlw	.16
	movwf	ctr
	call	bin2bcd
	call	Conv_IND_58		;   .
	return
Ind_Speeder
	clrf	bcd2
	movf	Speeder, W
	movwf	bcd3
	call	Conv_IND_14		;    .
	movf	cels_H2, W
	movwf	bcd2
	movf	cels_L2, W
	movwf	bcd3
	call	Conv_IND_58		;    .
	return
;-----------------------------------------------------------------------
;	  BIN>DEC      .
;-----------------------------------------------------------------------
Conv_IND_58
	btfsc	PORTA, 0	;   ,  
	goto	$+3			;  .
	btfss	flag, 0
	goto	Ind_OFF
	movlw	0x0F		;  1-.
	andwf	bcd3, W		; select 1dec. low razr.
	movwf	digit_8		; 4 -  . low.
	movlw	0xF0		;  2-.
	andwf	bcd3, F		;
	swapf	bcd3, W		;
	movwf	digit_7		; 3 -  .
	movlw	0x0F		;  3-.
	andwf	bcd2, W		;
	movwf	digit_6		; 2 -  .
	movlw	0xF0		;  4-.
	andwf	bcd2, F		;
	swapf	bcd2, W		;
	movwf	digit_5		; 1 -  . high.
	call	OFF_Zero_58
	return
;-----------------------------------------------------------------------
;	  BIN>DEC      .
;-----------------------------------------------------------------------
Conv_IND_14
	btfsc	PORTA, 0	;   ,  
	goto	$+3			;  .
	btfss	flag, 0
	goto	Ind_OFF
	movlw	0x0F		;  1-.
	andwf	bcd3, W		; select 1dec. low razr.
	movwf	digit_4		; 4 -  . low.
	movlw	0xF0		;  2-.
	andwf	bcd3, F		;
	swapf	bcd3, W		;
	movwf	digit_3		; 3 -  .
	movlw	0x0F		;  3-.
	andwf	bcd2, W		;
	movwf	digit_2		; 2 -  .
	movlw	0xF0		;  4-.
	andwf	bcd2, F		;
	swapf	bcd2, W		;
	movwf	digit_1		; 1 -  . high.
	call	OFF_Zero_14
	return
;=======================================================================
;				     .
;=======================================================================
OFF_Zero_14
	movf	digit_1, W	;    ?
	btfss	STATUS, Z	;  =0,
	return				;  >0,  .
	movlw	0x10		;       .
	movwf	digit_1
	movf	digit_2, W
	btfss	STATUS, Z
	return
	movlw	0x10
	movwf	digit_2
	return
;-----------------------------------------------------------------------
OFF_Zero_58
	movf	digit_5, W
	btfss	STATUS, Z
	return
	movlw	0x10
	movwf	digit_5
	movf	digit_6, W
	btfss	STATUS, Z
	return
	movlw	0x10
	movwf	digit_6
	return
;=======================================================================
;				    .
;=======================================================================
bin2bcd
	clrf bcd1
	clrf bcd2
	clrf bcd3
	goto conv
;-----------------------------------------------------------------------
adjdec
	movlw 0x33 
	addwf bcd1, f 
	addwf bcd2, f 
	addwf bcd3, f 
;-----------------------------------------------------------------------
	movlw 0x03 
	btfss bcd1, 3 
	subwf bcd1, f 
	btfss bcd2, 3 
	subwf bcd2, f 
	btfss bcd3, 3 
	subwf bcd3, f 
;-----------------------------------------------------------------------
	movlw 0x30 
	btfss bcd1, 7 
	subwf bcd1, f 
	btfss bcd2, 7 
	subwf bcd2, f 
	btfss bcd3, 7 
	subwf bcd3, f 
;-----------------------------------------------------------------------
conv
	rlf bin2, f 
	rlf bin1, f 
	rlf bcd3, f 
	rlf bcd2, f 
	rlf bcd1, f 
	decfsz ctr, f 
	goto adjdec
	return
;=======================================================================
;				   
;							 .
;=======================================================================
Water_T
	call	START_DS	;     DS18B20.
	call	Ind_LED
	call	READ_T		;    DS18B20.
	call	Ind_LED
	call	Cels_BinDec
	movf	cels_H, W
	movwf	cels_H1
	movf	cels_L, W
	movwf	cels_L1
	movf	minus, W
	movwf	minus1
	return
;-----------------------------------------------------------------------
Water_T_2
	call	START_DS_2	;     DS18B20.
	call	Ind_LED
	call	READ_T_2	;    DS18B20.
	call	Ind_LED
	call	Cels_BinDec
	movf	cels_H, W
	movwf	cels_H2
	movf	cels_L, W
	movwf	cels_L2
	movf	minus, W
	movwf	minus2
	return
;=======================================================================
;		        
;			 TEMP    , .
;=======================================================================
Cels_BinDec
;-----------------------------------------------------------------------
;		      .
;-----------------------------------------------------------------------
	movlw	.4
	movwf	ctr
loop
	bcf		STATUS, C
	rlf		LSB, f
	rlf		MSB, f
	decfsz	ctr, f
	goto	loop
;-----------------------------------------------------------------------
	bcf		minus, 1	;    .
	btfss	MSB, 7 		;   7 = 1,   .
	goto	BinDec
	movlw	0xFF
	xorwf	MSB, f
	bsf		minus, 1	;    .
	btfss	LSB, 7
	goto	BinDec
	movlw	0xFF
	xorwf	LSB, f
;-----------------------------------------------------------------------
BinDec
	movf	MSB, W
	movwf	ctr
	clrf	cels_L
	clrf	cels_H		;   .
	swapf	ctr, W		;      ,
	addwf	ctr, W		;      .
	andlw	0x0F
	skpndc				;     DC .
	addlw	0x16
	skpndc				;     DC .
	addlw	0x06
	addlw	0x06
	skpdc				;     DC .
	addlw	-0x06
	btfsc	ctr, 4
	addlw	0x16 - 1 + 0x06
	skpdc				;     DC .
	addlw	-0x06
	btfsc	ctr, 5
	addlw	0x30
	btfsc	ctr, 6
	addlw	0x60
	btfsc	ctr, 7
	addlw	0x20
	addlw	0x60
	rlf		cels_H, f
	btfss	cels_H, 0
	addlw	-0x60
	movwf	cels_L
	btfsc	ctr, 7
	incf	cels_H, f
	return
;=======================================================================
;        	  4-   LED-.
;			    10 ms. (10-).
;=======================================================================
Ind_LED
	movlw  	0x10
	movwf   cnt_Ind		;    .
loop_Ind
	movf	cnt3, W		;    .
	btfsc	STATUS, Z
	goto	loop_I
	decf	cnt3, f
loop_I
	call    Skaner		;   .
	decfsz  cnt_Ind, f	; cnt_ind=cnt_ind-1
	goto    loop_Ind
	return
;=======================================================================
;					  .
;=======================================================================
Skaner
	movf	digit_1, W	;  .
;		btfss	flag, 2		;     ,
;		goto	$+3
;		btfsc	minus1, 1	;      .
;		movlw	0x10
	btfss	flag, 4		;     .
	goto	$+3
	btfsc	flag, 6
	movlw	0x10
	call	Convert_HG1	;    .
	movwf	Ind_1		;      .
	movf	digit_5, W	;  .
;		btfss	flag, 2		;     ,
;		goto	$+3
;		btfsc	minus2, 1	;      .
;		movlw	0x10
	btfss	flag, 4		;     .
	goto	$+3
	btfss	flag, 6
	movlw	0x10
	call	Convert_HG2	;    .
	movwf	Ind_2		;      .
	call	Indicator	;   .
	bsf		key, 1		;    1.
	bcf		PORTB, 3
	call	Delay		;    .
	bsf		PORTB, 3	;   .
	bcf		key, 1		;    1.
;-----------------------------------------------------------------------
	movf    digit_2, W	;  .
		btfsc	flag, 1		;     ,
		goto	$+3
		btfsc	minus1, 1	;      .
		movlw	0x11
	btfss	flag, 4		;     .
	goto	$+3
	btfsc	flag, 6
	movlw	0x10
	call	Convert_HG1	;    .
	movwf	Ind_1		;      .
	btfsc	flag, 1		;   , 
	bcf		Ind_1, 6	;  .
	movf	digit_6, W	;  .
		btfsc	flag, 2		;     ,
		goto	$+3
		btfsc	minus2, 1	;      .
		movlw	0x11
	btfss	flag, 4		;     .
	goto	$+3
	btfss	flag, 6
	movlw	0x10
	call	Convert_HG2	;    .
	movwf	Ind_2		;      .
	call	Indicator	;   .
	bsf		key, 2		;    2.
	bcf		PORTB, 4
	call    Delay		;    .
	bsf		PORTB, 4	;   .
	bcf		key, 2		;    2.
;-----------------------------------------------------------------------
	movf    digit_3, W	;  .
	btfss	flag, 4		;     .
	goto	$+3
	btfsc	flag, 6
	movlw	0x10
	call	Convert_HG1	;    .
	movwf	Ind_1		;      .
	movf	digit_7, W	;  .
	btfss	flag, 4		;     .
	goto	$+3
	btfss	flag, 6
	movlw	0x10
	call	Convert_HG2	;    .
	movwf	Ind_2		;      .
	call	Indicator	;   .
	bsf		key, 3		;    3.
	bcf		PORTB, 5
	call    Delay		;    .
	bsf		PORTB, 5	;   .
	bcf		key, 3		;    3.
;-----------------------------------------------------------------------
	movf    digit_4, W	;  .
	btfss	flag, 4		;     .
	goto	$+3
	btfsc	flag, 6
	movlw	0x10
	call	Convert_HG1	;    .
	movwf	Ind_1		;      .
	movf	digit_8, W	;  .
	btfss	flag, 4		;     .
	goto	$+3
	btfss	flag, 6
	movlw	0x10
	call	Convert_HG2	;    .
	movwf	Ind_2		;      .
	call	Indicator	;   .
	bsf		key, 4		;    4.
	bcf		PORTB, 2
	call    Delay		;    .
	bsf		PORTB, 2	;   .
	bcf		key, 4		;    4.
;-----------------------------------------------------------------------
;					/   .
;-----------------------------------------------------------------------
	btfss	flag, 3
	return
	decfsz	Cnt_On_Off, f
	return
	btfsc	flag, 4
	goto	$+3
	bsf		flag, 4
	goto	$+2
	bcf		flag, 4
	movlw	0x32		;   /
	movwf	Cnt_On_Off	;   .
	return
;=======================================================================
;				     .
;=======================================================================
Indicator
	movlw	0x10
	movwf	cnt_dig		;      .
Count_dig
	bcf		PORTB, 1	;  RB1.
	btfsc	Ind_2, 0	;    .
	bsf		PORTB, 1	; =1    RB1.
	nop					; .
	bsf		PORTB, 6	;    RB6,    .
	nop					; .
	bcf		PORTB, 6	;  RB6. ( _||_ ).
	bcf		STATUS, C
	rrf		Ind_1, f	;      .
	rrf		Ind_2, f	;      .
	call	Forsunka
	decfsz	cnt_dig, f
	goto	Count_dig
	bcf		PORTB, 1	;  RB1.
	return
;=======================================================================
;			     
;							  .
;=======================================================================
Delay
	movf	cnt3, W		;     .
	btfsc	STATUS, Z	; =0    .
	call	Key			;  .
;-----------------------------------------------------------------------
	movlw   .10
	movwf   cnt1		; .10 -> cnt1
loop1 
	movlw   .73
	movwf   cnt2		; .73 -> cnt2
	clrwdt				;   .
loop2
	call	Forsunka
	decfsz  cnt2, f		; cnt2=cnt2-1
	goto	loop2
	decfsz  cnt1, f
	goto	loop1
	return
;=======================================================================
;					   .
;=======================================================================
Key
	btfss	PORTA, 1	;   RA1 = 0
	goto	Key_1		;   .
	return				;  .
;-----------------------------------------------------------------------
Key_1
	movlw	0x69		;   
	movwf	cnt3		;  .
	btfsc	key, 1		;   Sb1?
	goto	Sb_1		; ?     .
	btfsc	key, 2		;   Sb2?
	goto	Sb_2		; ?     .
	btfsc	key, 3		;   Sb3? , .
	goto	Sb_3		; ?     .
	btfsc	key, 4		;   Sb4? , .
	goto	Sb_4		; ?     .
	return
;-----------------------------------------------------------------------
Sb_1					;   .(->).
	btfsc	flag, 5		;     
	goto	Const_min	;  EEPROM,   .
	btfsc	flag, 3
	goto	Input_OFF
	bsf		flag, 1		;     .
	bcf		flag, 2
	bsf		flag, 3		;     .	
	return
Input_OFF
	bcf		flag, 1		;     .
	bcf		flag, 2
	bcf		flag, 3		;     .
	bcf		flag, 4
	bcf		flag, 6
	return
Const_min
	call	Inp_Const
	decf	Const, f
	call	Out_Const
	return
;-----------------------------------------------------------------------
Sb_2					;     .
	btfsc	PORTA, 0	;   ,   
	return				;   SB2.
	btfss	flag, 3		;     , 
	goto	Ind_on
	btfsc	flag, 5
	goto	Const_OFF
	bsf		flag, 5		;      EEPROM.
	bcf		flag, 1
	bcf		flag, 2
	bsf		flag, 6
	return
Const_OFF
	bcf		flag, 1
	bcf		flag, 2
	bcf		flag, 3		;   .
	bcf		flag, 4
	bcf		flag, 5		;      EEPROM.
	bcf		flag, 6
	call	WRITE_EPROM	;     EEPROM.
	return			
Ind_on
	btfsc	flag, 0
	goto	Ind_OFF
	bsf		flag, 0
	call	Ind_ON		;  .
	return
Ind_OFF					;  .
	bcf		flag, 0
	movlw	0x10
	movwf	digit_1
	movwf	digit_2
	movwf	digit_3
	movwf	digit_4
	movwf	digit_5
	movwf	digit_6
	movwf	digit_7
	movwf	digit_8
	return
;-----------------------------------------------------------------------
Sb_3					;   .(#).
	btfsc	flag, 5
	goto	Input_Constant
	btfss	flag, 3
	goto	Input_Constant
	btfsc	flag, 6
	goto	Rait_Ind_ON	
	bsf		flag, 6
	return
Rait_Ind_ON
	btfsc	flag, 2
	goto	Rait_Ind_OFF
	bsf		flag, 2
	return
Rait_Ind_OFF
	bcf		flag, 6
	bcf		flag, 2
	return
Input_Constant
	bcf		flag, 7		;      .
	btfsc	flag, 1		;    ?
	goto	Sel_Cels	; ,    .
	bsf		flag, 1		; ,     .
	bsf		flag, 7		;      .
	return
Sel_Cels
	btfsc	flag, 2
	goto	Sel_Speed
	bsf		flag, 2		;  .
	return
Sel_Speed
	bcf		flag, 1		;     .
	bcf		flag, 2		;      .
	return
;-----------------------------------------------------------------------
Sb_4					;  .(<-).
	btfsc	flag, 5		;     
	goto	Const_plus	;  EEPROM,   .
	btfss	flag, 3
	return
	btfsc	flag, 2
	goto	Set_Oil
	btfss	flag, 6
	goto	Clear_Speeder
	btfsc	flag, 6
	goto	Clear_Fors
	return
Clear_Speeder
	clrf	Speeder_1	;    .
	clrf	Speeder_2
	return
Clear_Fors
	clrf	Oil_razhod	;    .
	clrf	Dlit_Fors_2
	return
Set_Oil					;    .
	incf	Oil_zalito, f
	movf	Oil_zalito, W
	movwf	bin2
	clrf	bin1
	movlw	.16
	movwf	ctr
	call	bin2bcd		;_F
	call	Conv_IND
	return
Const_plus
	call	Inp_Const
	incf	Const, f
	call	Out_Const
	return
;-----------------------------------------------------------------------
Inp_Const
	btfsc	flag, 1
	goto	$+4
	movf	Speed, W
	movwf	Const
	return
	btfsc	flag, 2
	goto	$+4
	movf	Fors, W
	movwf	Const
	return
	movf	Speeder, W
	movwf	Const
	return
;-----------------------------------------------------------------------
Out_Const
	btfsc	flag, 1
	goto	$+4
	movf	Const, W
	movwf	Speed
	return
	btfsc	flag, 2
	goto	$+4
	movf	Const, W
	movwf	Fors
	return
	movf	Const, W
	movwf	Speeder
	return
;=======================================================================
;					    1-WIRE.
;=======================================================================
;		      
;						  DS18B20.
;=======================================================================
START_DS
	CALL	INIT		; .
	MOVLW	0xCC		;  Skip ROM    DS18B20.
	MOVWF	O_BYTE		;    .
	CALL	OUT_BYTE	;     .
	MOVLW	0x44		;  Convert T  
	MOVWF	O_BYTE		;  .
	CALL	OUT_BYTE	;     .
	return
;-----------------------------------------------------------------------
START_DS_2
	CALL	INIT_2		; .
	MOVLW	0xCC		;  Skip ROM    DS18B20.
	MOVWF	O_BYTE_2	;    .
	CALL	OUT_BYTE_2_1	;     .
	MOVLW	0x44		;  Convert T  
	MOVWF	O_BYTE_2	;  .
	CALL	OUT_BYTE_2_1	;     .
	return
;=======================================================================
;	       DS18B20
;=======================================================================
READ_T
	CALL	INIT		;      Reset.
	MOVLW	0xCC		;  Skip ROM    DS18B20.
	MOVWF	O_BYTE		;    .
	CALL	OUT_BYTE	;     .
	MOVLW	0xBE		;  Read Scratchpad  
	MOVWF	O_BYTE		;  DS18B20   .
	CALL	OUT_BYTE	;     .
;-----------------------------------------------------------------------
;						    .
;-----------------------------------------------------------------------
	CALL 	IN_BYTE		;   .
	MOVWF	LSB			; 0
	CALL 	IN_BYTE		;   .
	MOVWF	MSB			; 1
	return
;-----------------------------------------------------------------------
READ_T_2
	CALL	INIT_2		;      Reset.
	MOVLW	0xCC		;  Skip ROM    DS18B20.
	MOVWF	O_BYTE_2	;    .
	CALL	OUT_BYTE_2_1	;     .
	MOVLW	0xBE		;  Read Scratchpad  
	MOVWF	O_BYTE_2	;  DS18B20   .
	CALL	OUT_BYTE_2_1	;     .
;-----------------------------------------------------------------------
;						    .
;-----------------------------------------------------------------------
	CALL 	IN_BYTE_2	;   .
	MOVWF	LSB			; 0
	CALL 	IN_BYTE_2	;   .
	MOVWF	MSB			; 1
	return
;=======================================================================
;	 The following are common 1-Wire routines used in all applications
;						  1-Wire.
;=======================================================================
INIT
	CALL	PIN_HI		;    .
	CALL	PIN_LO		;    .
	MOVLW	.250		; 500 us delay (20mGz).
	CALL 	DELAY_10USEC; .
	CALL	PIN_HI		;    .
	MOVLW	.250		; 500 us delay  (20mGz).
	CALL 	DELAY_10USEC; .
	RETURN
;-----------------------------------------------------------------------
INIT_2
	CALL	PIN_HI_2
	CALL	PIN_LO_2
	MOVLW	.250		;  500 
	CALL	DELAY_10USEC
	CALL	PIN_HI_2
	MOVLW	.250		;  500 
	CALL	DELAY_10USEC
	RETURN
;-----------------------------------------------------------------------
;					     DS18B20.
;-----------------------------------------------------------------------
IN_BYTE					; returns byte in W
	MOVLW	.8
	MOVWF	_N
	CLRF	I_BYTE
IN_BYTE_1
	CALL	PIN_LO		; momentary low on DATA_PIN
	NOP
	CALL	PIN_HI
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	MOVF	PORTA, W	; 7 usecs later, fetch from DATA_PIN
	MOVWF	TEMP                                                        
	BTFSS	TEMP, DATA_PIN
	BCF		STATUS, C	; its a zero
	BTFSC	TEMP, DATA_PIN
	BSF		STATUS, C	; its a one
	RRF		I_BYTE, F
	MOVLW	.30			; now delay 60 usecs (20mGz).
	CALL	DELAY_10USEC
	DECFSZ	_N, F
	GOTO	IN_BYTE_1
	MOVF	I_BYTE, W	; return the result in W
	RETURN
;-----------------------------------------------------------------------
IN_BYTE_2				; returns byte in W
	MOVLW	.8
	MOVWF	_N
	CLRF	I_BYTE_2
IN_BYTE_1_2
	CALL	PIN_LO_2	; momentary low on DATA_PIN
	NOP
	CALL 	PIN_HI_2
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	MOVF	PORTB, W	; 7 usecs later, fetch from DATA_PIN
	MOVWF	TEMP_2
	BTFSS	TEMP_2, DATA_PIN_2
	BCF		STATUS, C	; its a zero
	BTFSC	TEMP_2, DATA_PIN_2
	BSF		STATUS, C	; its a one
	RRF		I_BYTE_2, F
	MOVLW	.30			; now delay 60 usecs
	CALL	DELAY_10USEC
	DECFSZ	_N, F
	GOTO	IN_BYTE_1_2
	MOVF	I_BYTE_2, W	; return the result in W
	RETURN
;-----------------------------------------------------------------------
;					     DS18B20.
;-----------------------------------------------------------------------
OUT_BYTE
	MOVLW	.8
	MOVWF	_N
OUT_BYTE_1
	RRF		O_BYTE, F
	BTFSS	STATUS, C
	GOTO	OUT_0
	GOTO	OUT_1	
OUT_BYTE_2
	DECFSZ	_N, F
	GOTO	OUT_BYTE_1
	RETURN
;-----------------------------------------------------------------------
OUT_BYTE_2_1
	MOVLW	.8
	MOVWF	_N
OUT_BYTE_1_2
	RRF		O_BYTE_2, F
	BTFSS	STATUS, C
	GOTO	OUT_0_2
	GOTO	OUT_1_2
OUT_BYTE_2_2
	DECFSZ	_N, F
	GOTO	OUT_BYTE_1_2
	RETURN
;-----------------------------------------------------------------------
OUT_0
	CALL	PIN_LO		; bring DATA_PIN low
	MOVLW	.30			; for 60 usecs (20mGz).
	CALL 	DELAY_10USEC
	CALL	PIN_HI
	GOTO	OUT_BYTE_2
;-----------------------------------------------------------------------
OUT_1
	CALL	PIN_LO		; momentary low
	CALL	PIN_HI
	MOVLW	.30			; for 60 usecs (20mGz).
	CALL 	DELAY_10USEC
	GOTO	OUT_BYTE_2
;-----------------------------------------------------------------------
PIN_HI
	BCF		INTCON,	GIE
	BSF		STATUS, RP0
	BSF		TRISA, DATA_PIN	; high impedance
	BCF		STATUS, RP0
	BSF		INTCON,	GIE
	RETURN
;-----------------------------------------------------------------------
OUT_0_2
	CALL	PIN_LO_2		; bring DATA_PIN low
	MOVLW	.30				; for 60 usecs
	CALL	DELAY_10USEC
	CALL	PIN_HI_2
	GOTO	OUT_BYTE_2_2
;-----------------------------------------------------------------------
OUT_1_2
	CALL	PIN_LO_2		; momentary low
	CALL	PIN_HI_2
	MOVLW	.30
	CALL	DELAY_10USEC
	GOTO	OUT_BYTE_2_2
;-----------------------------------------------------------------------
PIN_HI_2
	BCF		INTCON,	GIE
	BSF		STATUS, RP0
	BSF		TRISB, DATA_PIN_2	; high impedance
	BCF		STATUS, RP0
	BSF		INTCON,	GIE
	RETURN
;-----------------------------------------------------------------------
PIN_LO
	BCF		INTCON,	GIE
	BCF		PORTA, DATA_PIN
	BSF		STATUS, RP0
	BCF		TRISA, DATA_PIN		; low impedance zero
	BCF		STATUS, RP0
	BSF		INTCON,	GIE
	RETURN
;-----------------------------------------------------------------------
PIN_LO_2
	BCF		INTCON,	GIE
	BCF		PORTB, DATA_PIN_2
	BSF		STATUS, RP0
	BCF		TRISB, DATA_PIN_2	; low impedance zero
	BCF		STATUS, RP0
	BSF		INTCON,	GIE
	RETURN
;-----------------------------------------------------------------------
DELAY_10USEC				; provides a delay equal to W * 10 usecs
	MOVWF	LOOP1
DELAY_100USEC_1
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECFSZ	LOOP1, F
	GOTO	DELAY_100USEC_1
	RETURN
;=======================================================================
	END
